% Program demo_3_1
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
% Computes and plots the attenuation of aliased components in FIR decimator. 
% FIR filter: program requests the FIR filter coefficeints.
% Sampling frequencies: input Fx=10000 Hz, output Fy=2000 Hz.
% Decimation factor M=5.
close all
h=input('Insert the FIR filter coefficients ')
[H,f]=freqz(h,1,1001,10000);
n=0:length(h)-1;
Fx=10000; % input sampling frequency
M=5; % decimation factor
Fy=2000; % output sampling frequency
for r=1:1001
    F(r)=(r-1)*Fx/2000;
omega=2*pi*F(r)/Fx;
W=exp(-i*n*omega);
H(r)=sum(h.*W); % FIR filter frequency response
end

figure (1)
subplot(2,1,1)
plot(F,20*log10(abs(H)))
xlabel('Frequency, Hz'),ylabel('Magnitude, dB')
axis([0,5000,-80,5]), grid
subplot(2,1,2)
% Computation of aliasing in the frequency band of the low-rate signal.
% For k=0 program computes unaliased component.
% For k=1,2,3,4 program computes the aliased components.
k=0;
for l=1:5
for r=1:201
    FF(r)=(r-1)*Fy/400;
omega=2*pi*FF(r)/Fy;
W2=exp(-i*n*(omega-2*k*pi)/M);
Hal(r)=sum(h.*W2);
end
k=k+1;
plot(FF,20*log10(abs(Hal)))
hold on
end
xlabel('Frequency, Hz'),ylabel('Magnitude, dB')
axis([0,1000,-80,5]), grid on
hold off
