% Program demo_3_2
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
% Integer-band decimation
clear all, close all
Fx=10000; M=5; Fy=2000;
F=[0,2100/5000,2800/5000,2900/5000,3100/5000,3400/5000,3800/5000,4000/5000,4500/5000,1];
A=[0,0.05,1,0,0,0.7,0.8,0,0.6,0];
x=fir2(511,F,A); % generating the input signal signal x[n]
[X,f]=freqz(x,1,1024,10000);
figure (1)
subplot(4,1,1)
plot(f,abs(X)), ylabel('|X(e^j^\omega)|')
hBP=firgr(68,[0,1800/5000,2200/5000,2800/5000,3200/5000,1],[0,0,1,1,0,0]); % bandpass filter
[HBP,f]=freqz(hBP,1,1024,10000);
subplot(4,1,2), plot(f,20*log10(abs(HBP))), ylabel('|H_B_P(e^j^\omega)|')
axis([0,5000,-60,5])
v=filter(hBP,1,x); % bandpass filtering
[V,f]=freqz(v,1,1024,10000);
subplot(4,1,3), plot(f,abs(V)), ylabel('|V(e^j^\omega)|')
y=downsample(v,5); % downsampling
[Y,ff]=freqz(y,1,1024,2000);
subplot(4,1,4); plot(ff,abs(Y)), ylabel('|Y(e^j^\omega)|')
xlabel('Frequency, Hz')
