% Program demo_3_3
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
% Integer-band interpolation
clear all,close all
Fx=2000; M=5; Fy=10000;
F=[0,100/1000,800/1000,900/1000,1]; A=[0,0,1,0,0];
x=fir2(102,F,A); % generating the input signal signal x[n]
figure (2)
[X,ff]=freqz(x,1,1024,2000);
subplot(4,1,1); plot(ff,abs(X)), ylabel('|Y(e^j^\omega)|')
xlabel('Frequency, Hz')
hBP=5*firgr(64,[0,2800/5000,3200/5000,3800/5000,4200/5000,1],[0,0,1,1,0,0]); % bandpass filter
v=upsample(x,5);% upsampling
[V,f]=freqz(v,1,1024,10000);
subplot(4,1,2)
plot(f,abs(V)), ylabel('|V(e^j^\omega)|')
[HBP,f]=freqz(hBP,1,1024,10000);
subplot(4,1,3)
plot(f,20*log10(abs(HBP))), ylabel('|H_B_P(e^j^\omega)|')
axis([0,5000,-60,5]) 
y=filter(hBP,1,v); % filtering
[Y,f]=freqz(y,1,1024,10000);
subplot(4,1,4)
plot(f,abs(Y)), ylabel('|Y(e^j^\omega)|')
xlabel('Frequency, Hz')
