% Example_3_2
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
clear all, close all
ap = 0.1; as = 60; Fp = 0.09;     Fs = 2/5-Fp; % Filter specifications
dev  = [(10^(ap/20)-1)/(10^(ap/20)+1),  10^(-as/20)]; % Passband and stopband ripples
F = [Fp Fs];   % Cutoff frequencies
A = [1 0];      % Desired amplitudes
[N,Fo,Ao,W] = firpmord(F,A,dev);  % Estimating the filter order

h = firpm(N+3,Fo,Ao,W);
figure (1)
freqz(h,1,1024)
axis([0,1,-80,5])
figure (2)
subplot(2,1,1)
impz(h,1)
subplot(2,1,2)
zplane(h,1)

figure (3)
[H,f]=freqz(h,1,1024,2);
k=fix(1024*0.09);
subplot(4,3,1:2)
plot(f(1:k+1), 20*log10(abs(H(1:k+1))))
xlabel('Normalized frequency, x\pi')
title('Passband magnitude, dB')