% Example_3_3
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
clear all, close all
ap=0.1; as=60; M = 5;
Fp=0.09;      ; %Fs=2/5-Fp;
dev = [(10^(ap/20)-1)/(10^(ap/20)+1),10^(-as/20),10^(-as/20),10^(-as/20)]; 
F = [Fp,2/M-Fp,2/M+Fp,4/M-Fp,4/M+Fp,1];   % Cutoff frequencies
A = [1,0,0,0];      % Desired amplitudes
[Nord,Fo,Ao,W] = firpmord(F,A,dev);
Nord = 26; 
Fop = [0, Fp]; % Passband boundary frequencies
Fos1 = [2/M-Fp,2/M+Fp]; % Stopband 1 boundary frequencies
Fos2 = [4/M-Fp,4/M+Fp]; % Stopband 2 boundary frequencies
Fo= [Fop, Fos1, Fos2]; % Vector of normalized frequency points
Ao = [1,1,0,0,0,0]; W =[1.0000,5.7564,5.7564];
h = firpm(Nord,Fo,Ao,W);
figure (1)
freqz(h,1,1024)
axis([0,1,-80,5])
%hold on
%subplot(2,1,1), plot([Fo(1),Fo(2),Fo(3),Fo(3),Fo(4),Fo(4),Fo(5),Fo(5),Fo(6),Fo(6)],[0,0,0,-60,-60,0,0,-60,-60,0])
figure (2)
subplot(2,1,1)
impz(h,1)
subplot(2,1,2)
zplane(h,1)

figure (3)
[H,f]=freqz(h,1,1024,2);
k=fix(1024*0.09);
subplot(4,3,1:2)
plot(f(1:k+1), 20*log10(abs(H(1:k+1))))
xlabel('Normalized frequency, x\pi')
title('Passband magnitude, dB')