% Example_3_4
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
clear all, close all
Fp=0.09;      ; Fs=1/5;
Nord = 38; Fo = [ 0, Fp, Fs, 1.0000]; Ao = [1, 1, 0, 0]; W =  [1.0000, 200];
h = firgr (Nord,Fo,Ao,W,'minphase'); % Filter coefficients
figure (1)
freqz(h,1,1024)
axis([0,1,-80,5])
figure (2)
subplot(2,1,1)
impz(h,1)
subplot(2,1,2)
zplane(h,1)

figure (3)
[H,f]=freqz(h,1,1024,2);
k=fix(1024*0.09);
subplot(4,3,1:2)
plot(f(1:k+1), 20*log10(abs(H(1:k+1))))
xlabel('Normalized frequency, x\pi')
title('Passband magnitude, dB')