% Example_3_5
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
clear all, close all
[h,g] = ifir(3,'low',[.09 .2],[0.00575639914962 .001]); % Design of H(z^L) and G(z)
[H,w] = freqz(h,1,1024); [G,w]=freqz(g,1,1024); % Computing the frequency responses of H(z) and G(z)
hIFIR = conv(h,g); % Computing the overall impulse response of the interpolated filter

[HIFIR,w] = freqz(hIFIR,1,1024); % Computing the frequency response of the interpolated filter

figure (1)
subplot(2,1,1), 
plot(w/pi,20*log10(abs(H)),w/pi,20*log10(abs(G)))
legend('Periodic Filter','Image Suppressor Filter');
ylabel('Magnitude (dB)')
axis([0,1,-80,5])
subplot(2,1,2)
plot(w/pi,20*log10(abs(HIFIR)))
legend('Overall Filter');
ylabel('Magnitude (dB)') 
xlabel('Normalized frequency')
axis([0,1,-150,5])
figure (2)
subplot(2,2,1), stem(0:length(h)-1,h)
ylabel('h[n]'),xlabel('n'), axis([0,51,-0.1,0.4])
subplot(2,2,2), stem(0:length(g)-1,g)
ylabel('g[n]'),xlabel('n'), axis([0,14,-0.1,0.3])
subplot(2,2,3), stem(0:length(hIFIR)-1,hIFIR)
ylabel('h_I_F_I_R[n]'),xlabel('n'), axis([0,length(hIFIR)-1,-0.05,0.15])
subplot(2,2,4), zplane(hIFIR,1)
figure (3)
k=fix(1024*0.09);
subplot(4,3,1:2)
plot(w(1:k+1)/pi, 20*log10(abs(HIFIR(1:k+1))))
xlabel('Normalized frequency')
title('Passband magnitude, dB')