% Example_3_7
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
% clear all, close all
% First run, N=5, second run N=7
% Take care obout subplots for the pole/zero plot
ap=0.1; as=60;
Fp=0.09; 
[B,A]=cheby1(5,ap,Fp); 

figure (1)
freqz(B,A,1024) % Computes and plots the frequency response
axis([0,1,-80,5])
hold on

figure (2)
subplot(2,2,1:2)
impz(B,A) % Plots the impulse response
axis([0,60,-0.05,0.15])
hold on

figure (2)
subplot(2,2,1:2)
impz(B,A) % Plots the impulse response
axis([0,60,-0.05,0.15])
hold on

figure (2)
subplot(2,2,4)
zplane(B,A) % Pole/zero plot
axis([-1.2,1.2,-1.2,1.2])
hold on

figure (3)
[H,f]=freqz(B,A,1024,2);
k=fix(1024*0.09);
subplot(4,3,1:2)
plot(f(1:k+1), 20*log10(abs(H(1:k+1))))
axis([0,0.1,-0.1,0.01])
hold on
xlabel('Normalized frequency, x\pi')
title('Passband magnitude, dB')





