% Example_3_8_a
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
close all, clear all

ap=0.1; as=60;
Fp=0.09; Fs=1/5;
dev = [(10^(ap/20)-1)/(10^(ap/20)+1)  10^(-as/20)]; 
F = [Fp 1/5];   % Cutoff frequencies
A = [1 0];      % Desired amplitudes
[Nord,Fo,Ao,W] = firpmord(F,A,dev)
h = firpm(Nord+4,Fo,Ao,W); % Filter coefficients
n=0:length(h)-1;
Fx=10000;
M=5;
Fy=2000;
for r=1:1001
    F(r)=(r-1)*Fx/2000;
omega=2*pi*F(r)/Fx;
W=exp(-i*n*omega);
H(r)=sum(h.*W);
end

figure (1)
subplot(2,1,1)
plot(F,20*log10(abs(H)))
xlabel('Frequency, Hz'),ylabel('Magnitude, dB')
axis([0,5000,-80,5]), grid

subplot(2,1,2)
k=0;
for l=1:5
for r=1:201
    FF(r)=(r-1)*Fy/400;
omega=2*pi*FF(r)/Fy;
W2=exp(-i*n*(omega-2*k*pi)/M);
Hal(r)=sum(h.*W2);
end
k=k+1;
plot(FF,20*log10(abs(Hal)))
hold on
end
xlabel('Frequency, Hz'),ylabel('Magnitude, dB')
axis([0,1000,-80,5]), grid on
hold off
